"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ui_1 = require("@/components/ui");
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var button_1 = __importDefault(require("@/library/button"));
var label_1 = __importDefault(require("@/library/label"));
var social_button_1 = __importDefault(require("@/library/social-button"));
var textfield_1 = __importDefault(require("@/library/textfield"));
var top_navigation_1 = __importDefault(require("@/library/top-navigation"));
var switch_1 = __importDefault(require("@/library/switch"));
var react_native_reanimated_1 = require("react-native-reanimated");
var check_box_1 = __importDefault(require("@/library/check-box"));
var main_page_header_1 = __importDefault(require("@/library/main-page-header"));
var text_1 = __importDefault(require("@/library/text"));
var icon_button_1 = __importDefault(require("@/library/icon-button"));
var test_circle_1 = __importDefault(require("@/library/icons/test-circle"));
var full_circle_1 = require("@/library/icons/full-circle");
var empty_circle_1 = require("@/library/icons/empty-circle");
var menu_item_1 = __importDefault(require("@/library/menu-item"));
var search_bar_1 = __importDefault(require("@/library/search-bar"));
var location_black_shape_1 = require("@/library/icons/location-black-shape");
var popup_modal_1 = __importDefault(require("@/library/popup-modal"));
var snack_bar_1 = __importDefault(require("@/library/snack-bar"));
var check_1 = __importDefault(require("@/library/check"));
var IconDummyComponent = function () {
    return <ui_1.View className="w-6 h-6 bg-red-500 rounded-full"/>;
};
var IconDummyComponent2 = function () {
    return <ui_1.View className="w-6 h-6 bg-blue-500 rounded-full"/>;
};
function Paper() {
    var _a = React.useState(''), text = _a[0], setText = _a[1];
    var _b = React.useState(''), passwordText = _b[0], setPasswordText = _b[1];
    var _c = React.useState(true), passwordVisible = _c[0], setPasswordVisible = _c[1];
    var _d = React.useState(''), countText = _d[0], setCountText = _d[1];
    var _e = React.useState(false), testToggle = _e[0], setTestToggle = _e[1];
    var searchBarRef = React.useRef(null);
    var _f = React.useState({
        status: 'none',
        message: '',
    }), passwordStatusConfig = _f[0], setPasswordStatusConfig = _f[1];
    var _g = React.useState({
        status: 'none',
        message: '',
    }), statusConfig = _g[0], setStatusConfig = _g[1];
    var _h = React.useState({ first: '', second: '' }), idValue = _h[0], setIdValue = _h[1];
    var _j = React.useState({
        status: 'none',
        message: '',
    }), idStatusConfig = _j[0], setIdStatusConfig = _j[1];
    function handlePasswordChange(inputText) {
        setPasswordText(inputText);
        if (inputText.length >= 8) {
            setPasswordStatusConfig({
                status: 'success',
                message: '유효한 비밀번호입니다.',
            });
        }
        else {
            setPasswordStatusConfig({
                status: 'error',
                message: '비밀번호는 최소 8자 이상이어야 합니다.',
            });
        }
    }
    function handlePasswordClear() {
        setPasswordText('');
        setPasswordStatusConfig({
            status: 'none',
            message: '',
        });
    }
    var handleIdChange = {
        onFirstChange: function (text) {
            setIdValue(function (prev) { return (__assign(__assign({}, prev), { first: text })); });
            validateId(text, idValue.second);
        },
        onSecondChange: function (text) {
            setIdValue(function (prev) { return (__assign(__assign({}, prev), { second: text })); });
            validateId(idValue.first, text);
        },
    };
    function validateId(first, second) {
        // ID 유효성 검사: 앞 6자리, 뒤 1자리
        if (first.length === 6 && second.length === 1) {
            setIdStatusConfig({
                status: 'success',
                message: '유효한 주민등록번호입니다.',
            });
        }
        else {
            setIdStatusConfig({
                status: 'error',
                message: '앞 6자리와 뒤 1자리를 입력해야 합니다.',
            });
        }
    }
    function handleClear() {
        setIdValue({ first: '', second: '' });
        setIdStatusConfig({
            status: 'none',
            message: '',
        });
    }
    var handleCustomValidation = function (text) {
        if (text.length <= 10 && /^[a-zA-Z]*$/.test(text)) {
            // 예: 10자 이하, 알파벳만 허용
            setCountText(text);
        }
    };
    // Top Navigation
    var TestComponent = function () {
        return <ui_1.View className="w-[24px] h-[24px] bg-blue-500 rounded-full"/>;
    };
    var _k = React.useState('테스트'), activeTab = _k[0], setActiveTab = _k[1];
    // Switch
    var isOn = (0, react_native_reanimated_1.useSharedValue)(true);
    var handlePress = function () {
        isOn.value = !isOn.value;
        setTestToggle(function (prev) { return !prev; });
        console.log(isOn.value);
    };
    // checkbox
    var _l = React.useState(true), checked = _l[0], setChecked = _l[1];
    var handleTextChange = function (inputText) {
        setText(inputText);
        if (inputText.length < 3) {
            setStatusConfig({
                status: 'error',
                message: '에러 메시지 표기',
            });
        }
        else {
            // 상황에 따라 성공 표기를 하고싶지 않다면, status는 'none'으로 설정, message는 ''로 설정
            setStatusConfig({
                status: 'success',
                message: '성공 메시지 표기',
            });
        }
    };
    var _m = React.useState(''), searchText = _m[0], setSearchText = _m[1];
    var handleSearch = function () {
        console.log(searchText, 'submit');
    };
    var _o = React.useState(false), isVisible = _o[0], setIsVisible = _o[1];
    var _p = React.useState(false), loading = _p[0], setLoading = _p[1];
    var _q = React.useState(false), isChecked = _q[0], setIsChecked = _q[1];
    return (<top_navigation_1.default backgroundColor="white" barStyle={'dark-content'}>
      <main_page_header_1.default tabTitle={['테스트', '테스트2']} 
    // tabTitle={['테스트']}
    activeTab={activeTab} onTabChange={setActiveTab} funcComponent={[
            <icon_button_1.default required={true} icon={<test_circle_1.default />} onPress={function () {
                    var _a;
                    console.log('CLICK');
                    (_a = searchBarRef.current) === null || _a === void 0 ? void 0 : _a.blur();
                }}/>,
        ]}/>
      {/* <SubPageHeader
          title={'Middle Title'}
          subTitle={'보조하는 텍스트 (옵션)'}
          subContent={'타이틀은 최대 두줄까지만\n입력하세요.'}
          exitEvent={() => console.log('exit')}
          exitIcon={<TestCircle />}
          funcComponent={[
            <IconButton
              required={true}
              icon={<TestCircle />}
              onPress={() => console.log('CLICK1')}
            />,
            <IconButton
              required={true}
              icon={<TestCircle />}
              onPress={() => console.log('CLICK2')}
            />,
            <IconButton
              // required={true}
              hitSlop={{ top: 8, bottom: 8, left: 8, right: 40 }}
              icon={<TestCircle />}
              onPress={() => console.log('CLICK3')}
            />,
          ]}
        /> */}
      <react_native_1.TouchableWithoutFeedback onPress={react_native_1.Keyboard.dismiss}>
        <ui_1.View className="justify-center gap-4 px-[16px]">
          {activeTab === '테스트' && (<ui_1.View>
              <text_1.default face={'title'} size="xlarge" weight="bold" textColor={"black"}>
                {'텍스트'}
              </text_1.default>
              {/* 정적 라벨 */}
              <label_1.default value={'라벨 텍스트'} labelClassName="text-sm" isLabelOnly required/>

              <menu_item_1.default activeIcon={<full_circle_1.FullCircleIcon />} idleIcon={<empty_circle_1.EmptyCircleIcon />} menuTitle={'타이틀'} selected={testToggle} badge={{ variant: 'dot' }}/>

              <full_circle_1.FullCircleIcon />
              <empty_circle_1.EmptyCircleIcon />

              <text_1.default face={'display'} size="small">
                Display small
              </text_1.default>
              <text_1.default face={'display'} size="medium">
                Display medium
              </text_1.default>
              <text_1.default face={'display'} size="large">
                Display large
              </text_1.default>
              <text_1.default face={'display'} size="xlarge" textColor="gray-400">
                Display xlarge
              </text_1.default>

              {/* 카운팅 라벨 */}
              <label_1.default value={countText} onChangeText={handleCustomValidation} labelClassName="text-lg" characterCount={true} maxCharacterCount={10}/>

              <check_box_1.default 
        // backgroundColor={'orange'}
        // backgroundColor={'red'}
        // disabled={true}
        backgroundColor={'brand-primary-default'} className="rounded-full" checked={checked} onChange={function () {
                console.log(!checked ? 'checked' : 'unchecked');
                setChecked(!checked);
            }}/>
              <switch_1.default trackColors={{ on: '#10B981', off: '#E5E7EB' }} 
        // disabled={true}
        value={isOn} onPress={handlePress} style={{ width: 42, height: 24, padding: 3 }}/>
              <ui_1.View style={{
                backgroundColor: 'green',
                // justifyContent: 'center',
                flexDirection: 'row',
            }}>
                <text_1.default face={'paragraph'} size="2xlarge" 
        // textColor={'brand-primary-default'}
        weight={'extrabold'} className="py-[10px] bg-red-500">
                  paragraph 2xlarge
                </text_1.default>
              </ui_1.View>
              <react_native_1.Text style={{ backgroundColor: 'yellow' }}>??????</react_native_1.Text>

              {/* <RNText className="text-prime-text-10">text-Prime Text 10</RNText>
            <RNText className="text-prime-text-12">text-Prime Text 12</RNText>
            <RNText className="text-prime-text-14">text-Prime Text 14</RNText>
            <RNText className="text-prime-text-16">text-Prime Text 16</RNText>
            <RNText className="text-prime-text-20">text-Prime Text 20</RNText>
            <RNText className="text-prime-text-24">text-Prime Text 24</RNText>
            <RNText className="text-prime-text-32">text-Prime Text 32</RNText>
            <RNText className="text-prime-paragraph-13">
              text-prime-paragraph-13
            </RNText>
            <RNText className="text-prime-paragraph-14">
              text-prime-paragraph-14
            </RNText>
            <RNText className="text-prime-paragraph-15">
              text-prime-paragraph-15
            </RNText>
            <RNText className="text-prime-paragraph-16">
              text-prime-paragraph-16
            </RNText>
            <RNText className="text-prime-paragraph-18">
              text-prime-paragraph-18
            </RNText> */}
            </ui_1.View>)}
          {activeTab === '테스트2' && (<>
              <search_bar_1.default ref={searchBarRef} backgroundColor={'#F3F4F6'} value={searchText} onChangeText={setSearchText} onClear={function () { return setSearchText(''); }} onSubmit={handleSearch} placeholder={'검색어를 입력해주세요.'} onFocus={function () { return console.log('focus'); }} onBlur={function () { return console.log('blur'); }} blurIcon={false ? <location_black_shape_1.LocationBlackShapeIcon /> : null}/>
              <textfield_1.default label={{
                text: '라벨',
                className: 'text-sm',
            }} input={{
                mode: 'default',
                value: text,
                placeholder: '홍길동',
            }} statusConfig={statusConfig} onClear={function () {
                setText('');
                setStatusConfig({
                    status: 'none',
                    message: '',
                });
            }} onChangeText={handleTextChange}/>
              <textfield_1.default label={{
                text: '비밀번호',
            }} input={{
                mode: 'password',
                value: passwordText,
                placeholder: '비밀번호',
                isSecureTextEntry: passwordVisible,
                onSecureTextEntryChange: setPasswordVisible,
            }} statusConfig={passwordStatusConfig} onChangeText={handlePasswordChange} onClear={handlePasswordClear}/>
              <popup_modal_1.default isVisible={isVisible} mainTitle="업데이트 안내" subTitle="보다 좋은 서비스를 위해 새 버전을 이용해주세요." onClose={function () { return setIsVisible(false); }} onConfirm={function () { return console.log('confirm'); }} cancelButton={{
                text: '취소',
                variant: 'danger',
                shape: 'pill',
                className: 'flex-1',
            }} confirmButton={{
                text: '확인',
                variant: 'dangerLow',
                shape: 'pill',
                className: 'flex-1',
            }}/>

              {/* <CommonModal
              isVisible={isVisible}
              mainTitle="알림"
              subTitle="처리가 완료되었습니다."
              onClose={() => setIsVisible(false)}
            /> */}
              <ui_1.View className="flex-row gap-4  w-full">
                <button_1.default 
        // disabled={true}
        // loading={true}
        variant="outlined" text={'테스트LEFT'} shape="pill" className="flex-1" leftIcon={{
                icon: <test_circle_1.default />,
                gap: 4,
            }} 
        // backgroundColor={'brand-primary-default'}
        // textColor={'blue'}
        // onPress={() => setIsVisible(true)}
        onPress={function () {
                setLoading(false);
            }}/>
                <button_1.default 
        // disabled={true}
        // loading={true}
        variant="primaryLow" text={'스낵바테스트'} className="flex-1" shape={'round'} 
        // backgroundColor={'brand-primary-default'}
        // textColor={'blue'}
        // onPress={() => console.log('테스트')}
        onPress={function () {
                // showSnackBar({
                //   styleTheme: 'dark',
                //   variant: 'thumbnail',
                //   thumbnailProps: {
                //     imageUrl: 'https://placehold.co/600x400',
                //     title: '타이틀',
                //     description: '설명',
                //   },
                //   className: 'mb-[42px]',
                //   rightTextButton: true,
                //   buttonText: '보기',
                // });
                // dismissLoadingSnackBar();
                (0, snack_bar_1.default)({
                    variant: 'success',
                    message: '변경되었어요2.',
                    className: 'mb-[48px]',
                });
            }}/>
              </ui_1.View>
              <button_1.default 
        // disabled={true}
        // loading={true}
        variant="primaryLow" text={'테스트!!!!'} shape={'round'} 
        // backgroundColor={'brand-primary-default'}
        // textColor={'blue'}
        onPress={function () {
                // showSnackBar({
                //   message: 'AI 답변 생성중...',
                //   styleTheme: 'dark',
                //   loading: true,
                // });
                (0, snack_bar_1.default)({
                    variant: 'success',
                    message: '변경되었어요.',
                    className: 'mb-[48px]',
                });
                // setLoading(true);
                // // 로딩 시작 시 스낵바 표시
                // showSnackBar({
                //   message: 'AI 답변 생성중..!!!.',
                //   styleTheme: 'dark',
                //   loading: true,
                // });
                // // 작업 완료 후
                // setTimeout(() => {
                //   setLoading(false);
                //   // updateSnackBar 사용
                //   updateSnackBar({
                //     variant: 'success',
                //     message: '생성 완료',
                //     styleTheme: 'dark',
                //     loading: false,
                //     duration: 5000,
                //   });
                // }, 1500);
            }}/>
              <social_button_1.default type="google" onPress={function () { return console.log('카카오 로그인'); }}/>
            </>)}

          <check_1.default checked={isChecked} disabled={false} onPress={function () { return setIsChecked(!isChecked); }}/>
        </ui_1.View>
      </react_native_1.TouchableWithoutFeedback>
    </top_navigation_1.default>);
}
exports.default = Paper;
//# sourceMappingURL=paper.js.map