import React from 'react';
import type { SubmitHandler } from 'react-hook-form';
import * as z from 'zod';
declare const schema: z.ZodObject<{
    name: z.ZodOptional<z.ZodString>;
    email: z.ZodString;
    password: z.ZodString;
}, "strip", z.ZodTypeAny, {
    email: string;
    password: string;
    name?: string | undefined;
}, {
    email: string;
    password: string;
    name?: string | undefined;
}>;
export type FormType = z.infer<typeof schema>;
export type LoginFormProps = {
    onSubmit?: SubmitHandler<FormType>;
};
export declare const LoginForm: ({ onSubmit }: LoginFormProps) => React.JSX.Element;
export {};
//# sourceMappingURL=login-form.d.ts.map