"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThemeItem = void 0;
var react_1 = __importDefault(require("react"));
var ui_1 = require("@/components/ui");
var lib_1 = require("@/lib");
var item_1 = require("./item");
var ThemeItem = function () {
    var _a = (0, lib_1.useSelectedTheme)(), selectedTheme = _a.selectedTheme, setSelectedTheme = _a.setSelectedTheme;
    var modal = (0, ui_1.useModal)();
    var onSelect = react_1.default.useCallback(function (option) {
        setSelectedTheme(option.value);
        modal.dismiss();
    }, [setSelectedTheme, modal]);
    var themes = react_1.default.useMemo(function () { return [
        { label: "".concat((0, lib_1.translate)('settings.theme.dark'), " \uD83C\uDF19"), value: 'dark' },
        { label: "".concat((0, lib_1.translate)('settings.theme.light'), " \uD83C\uDF1E"), value: 'light' },
        { label: "".concat((0, lib_1.translate)('settings.theme.system'), " \u2699\uFE0F"), value: 'system' },
    ]; }, []);
    var theme = react_1.default.useMemo(function () { return themes.find(function (t) { return t.value === selectedTheme; }); }, [selectedTheme, themes]);
    return (<>
      <item_1.Item text="settings.theme.title" value={theme === null || theme === void 0 ? void 0 : theme.label} onPress={modal.present}/>
      <ui_1.Options ref={modal.ref} options={themes} onSelect={onSelect} value={theme === null || theme === void 0 ? void 0 : theme.value}/>
    </>);
};
exports.ThemeItem = ThemeItem;
//# sourceMappingURL=theme-item.js.map