"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ControlledInput = exports.Input = void 0;
var React = __importStar(require("react"));
var react_hook_form_1 = require("react-hook-form");
var react_native_1 = require("react-native");
var react_native_2 = require("react-native");
var tailwind_variants_1 = require("tailwind-variants");
var colors_1 = __importDefault(require("./colors"));
var text_1 = require("./text");
var inputTv = (0, tailwind_variants_1.tv)({
    slots: {
        container: 'mb-2',
        label: 'text-grey-100 mb-1 text-lg dark:text-neutral-100',
        input: 'mt-0 rounded-xl border-[0.5px] border-neutral-300 bg-neutral-100 px-4 py-3 font-inter text-base  font-medium leading-5 dark:border-neutral-700 dark:bg-neutral-800 dark:text-white',
    },
    variants: {
        focused: {
            true: {
                input: 'border-neutral-400 dark:border-neutral-300',
            },
        },
        error: {
            true: {
                input: 'border-danger-600',
                label: 'text-danger-600 dark:text-danger-600',
            },
        },
        disabled: {
            true: {
                input: 'bg-neutral-200',
            },
        },
    },
    defaultVariants: {
        focused: false,
        error: false,
        disabled: false,
    },
});
exports.Input = React.forwardRef(function (props, ref) {
    var label = props.label, error = props.error, testID = props.testID, inputProps = __rest(props, ["label", "error", "testID"]);
    var _a = React.useState(false), isFocussed = _a[0], setIsFocussed = _a[1];
    var onBlur = React.useCallback(function () { return setIsFocussed(false); }, []);
    var onFocus = React.useCallback(function () { return setIsFocussed(true); }, []);
    var styles = React.useMemo(function () {
        return inputTv({
            error: Boolean(error),
            focused: isFocussed,
            disabled: Boolean(props.disabled),
        });
    }, [error, isFocussed, props.disabled]);
    return (<react_native_1.View className={styles.container()}>
      {label && (<text_1.Text testID={testID ? "".concat(testID, "-label") : undefined} className={styles.label()}>
          {label}
        </text_1.Text>)}
      <react_native_2.TextInput testID={testID} ref={ref} placeholderTextColor={colors_1.default.neutral[400]} className={styles.input()} onBlur={onBlur} onFocus={onFocus} {...inputProps} style={react_native_1.StyleSheet.flatten([
            { writingDirection: react_native_1.I18nManager.isRTL ? 'rtl' : 'ltr' },
            { textAlign: react_native_1.I18nManager.isRTL ? 'right' : 'left' },
            inputProps.style,
        ])}/>
      {error && (<text_1.Text testID={testID ? "".concat(testID, "-error") : undefined} className="text-sm text-danger-400 dark:text-danger-600">
          {error}
        </text_1.Text>)}
    </react_native_1.View>);
});
// only used with react-hook-form
function ControlledInput(props) {
    var _a;
    var name = props.name, control = props.control, rules = props.rules, inputProps = __rest(props, ["name", "control", "rules"]);
    var _b = (0, react_hook_form_1.useController)({ control: control, name: name, rules: rules }), field = _b.field, fieldState = _b.fieldState;
    return (<exports.Input ref={field.ref} autoCapitalize="none" onChangeText={field.onChange} value={field.value || ''} {...inputProps} error={(_a = fieldState.error) === null || _a === void 0 ? void 0 : _a.message}/>);
}
exports.ControlledInput = ControlledInput;
//# sourceMappingURL=input.js.map