"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSelectedLanguage = exports.changeLanguage = exports.translate = exports.getLanguage = exports.LOCAL = void 0;
var i18next_1 = __importDefault(require("i18next"));
var lodash_memoize_1 = __importDefault(require("lodash.memoize"));
var react_1 = require("react");
var react_native_1 = require("react-native");
var react_native_mmkv_1 = require("react-native-mmkv");
var react_native_restart_1 = __importDefault(require("react-native-restart"));
var storage_1 = require("../storage");
exports.LOCAL = 'local';
var getLanguage = function () { return storage_1.storage.getString(exports.LOCAL); }; // 'Marc' getItem<Language | undefined>(LOCAL);
exports.getLanguage = getLanguage;
exports.translate = (0, lodash_memoize_1.default)(function (key, options) {
    if (options === void 0) { options = undefined; }
    return i18next_1.default.t(key, options);
}, function (key, options) {
    return options ? key + JSON.stringify(options) : key;
});
var changeLanguage = function (lang) {
    i18next_1.default.changeLanguage(lang);
    if (lang === 'ar') {
        react_native_1.I18nManager.forceRTL(true);
    }
    else {
        react_native_1.I18nManager.forceRTL(false);
    }
    if (react_native_1.Platform.OS === 'ios' || react_native_1.Platform.OS === 'android') {
        if (__DEV__)
            react_native_1.NativeModules.DevSettings.reload();
        else
            react_native_restart_1.default.restart();
    }
    else if (react_native_1.Platform.OS === 'web') {
        window.location.reload();
    }
};
exports.changeLanguage = changeLanguage;
var useSelectedLanguage = function () {
    var _a = (0, react_native_mmkv_1.useMMKVString)(exports.LOCAL), language = _a[0], setLang = _a[1];
    var setLanguage = (0, react_1.useCallback)(function (lang) {
        setLang(lang);
        if (lang !== undefined)
            (0, exports.changeLanguage)(lang);
    }, [setLang]);
    return { language: language, setLanguage: setLanguage };
};
exports.useSelectedLanguage = useSelectedLanguage;
//# sourceMappingURL=utils.js.map