"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var style_utils_1 = require("./style-utils");
var text_1 = __importDefault(require("./text"));
var Badge = function (props) {
    if (props.variant === 'dot') {
        var _a = props.dotPosition, dotPosition = _a === void 0 ? 'absolute top-0 right-0' : _a, _b = props.color, color = _b === void 0 ? 'emerald-500' : _b;
        return (<react_native_1.View className={"".concat(dotPosition, " mt-[-2px] mr-[-2px] w-[4px] h-[4px] rounded-full")} style={{ backgroundColor: (0, style_utils_1.getColor)(color) }}/>);
    }
    if (props.variant === 'new') {
        var _c = props.size, size = _c === void 0 ? 'medium' : _c, _d = props.color, color = _d === void 0 ? 'emerald-500' : _d;
        var numberBadgePosition = size === 'small' ? 'top-[-2] right-[-6]' : 'top-[-4] right-[-8]';
        return (<react_native_1.View className={"absolute rounded-full justify-center items-center ".concat(numberBadgePosition)} style={{
                backgroundColor: (0, style_utils_1.getColor)(color),
                width: size === 'medium' ? 20 : 16,
                height: size === 'medium' ? 20 : 16,
            }}>
        <text_1.default face={'caption'} weight={'semibold'} size={size === 'medium' ? 'medium' : 'small'} textColor={'white'}>
          N
        </text_1.default>
      </react_native_1.View>);
    }
    if (props.variant === 'number') {
        var _e = props.count, count = _e === void 0 ? 1 : _e, _f = props.size, size = _f === void 0 ? 'medium' : _f, _g = props.color, color = _g === void 0 ? 'emerald-500' : _g;
        var isCountLarge = count > 99;
        var adjustedRight = isCountLarge
            ? size === 'small'
                ? '-16'
                : '-20'
            : size === 'small'
                ? '-6'
                : '-8';
        var adjustedPosition = size === 'small'
            ? "top-[-2] right-[".concat(adjustedRight, "]")
            : "top-[-4] right-[".concat(adjustedRight, "]");
        return (<react_native_1.View className={"absolute rounded-full justify-center items-center ".concat(adjustedPosition)} style={{
                backgroundColor: (0, style_utils_1.getColor)(color),
                minWidth: size === 'medium' ? 20 : 16,
                height: size === 'medium' ? 20 : 16,
                paddingHorizontal: 4,
            }}>
        <text_1.default face={'caption'} weight={'semibold'} size={size === 'medium' ? 'medium' : 'small'} textColor={'white'}>
          {count > 99 ? '99+' : count}
        </text_1.default>
      </react_native_1.View>);
    }
};
exports.default = Badge;
//# sourceMappingURL=badge.js.map