"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var ui_1 = require("../components/ui");
var native_1 = require("@react-navigation/native");
var style_utils_1 = require("./style-utils");
var TopNavigation = React.forwardRef(function (_a, ref) {
    var children = _a.children, _b = _a.aosTopSafePadding, aosTopSafePadding = _b === void 0 ? true : _b, _c = _a.backgroundColor, backgroundColor = _c === void 0 ? '#000000' : _c, className = _a.className, _d = _a.barStyle, barStyle = _d === void 0 ? 'dark-content' : _d;
    var isFocused = (0, native_1.useIsFocused)();
    var Container = react_native_1.Platform.OS === 'ios' ? ui_1.SafeAreaView : react_native_1.View;
    var statusBarHeight = react_native_1.Platform.OS === 'android' ? react_native_1.StatusBar.currentHeight || 0 : 0;
    React.useEffect(function () {
        if (isFocused) {
            if (react_native_1.Platform.OS === 'android') {
                react_native_1.StatusBar.setBackgroundColor((0, style_utils_1.getColor)(backgroundColor));
            }
            react_native_1.StatusBar.setBarStyle(barStyle);
        }
    }, [isFocused, backgroundColor, barStyle]);
    return (<react_native_1.View ref={ref} className={"flex-1 ".concat(className)} style={[{ backgroundColor: (0, style_utils_1.getColor)(backgroundColor) }]}>
        <Container style={__assign({ flex: 1, backgroundColor: (0, style_utils_1.getColor)(backgroundColor) }, (react_native_1.Platform.OS === 'android'
            ? { paddingTop: aosTopSafePadding ? statusBarHeight : 0 }
            : {}))} {...(react_native_1.Platform.OS === 'ios' ? { edges: ['top'] } : {})}>
          {children}
        </Container>
      </react_native_1.View>);
});
exports.default = TopNavigation;
//# sourceMappingURL=top-navigation.js.map